// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.code;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import threadmark.IFarmer;

public class CodeFarmer implements IFarmer {
    
    private CodeWorker[] myWorkers;
    public static int BLOCK_COUNT = 5000; // Bekezdes ismetlese a generalt bemeneti fajlban.
    public static File JOB_DIR;           // Munkakonyvtar
    public static File JOB_FILE;          // Kodolando fajl
    
    public CodeFarmer() {
        JOB_FILE = new File("FileToCode.txt");
        JOB_FILE= JOB_FILE.exists() ? JOB_FILE : getJobFile();
    }
    
    public long getOperation(){
        return JOB_FILE.length();
    }
    
    public long getWriteBytes(){
        return JOB_FILE.length();
    }
    
    public long getReadBytes(){
        return JOB_FILE.length();
    }
    
    public void doWork(int maxWorker) {
        new File("CodeTest").mkdir();
        JOB_DIR = new File("CodeTest", "WorkerCount_" + Integer.toString(maxWorker));
        JOB_DIR.mkdir();
        myWorkers = new CodeWorker[maxWorker];
        long block = JOB_FILE.length() / maxWorker; // Feldolgozasi egyseg merete.
        long mod = JOB_FILE.length() % maxWorker;   // Maradek a file vegen, az utolso munkas kapja.
        for(int i = 0; i < maxWorker; i++) {
            if(i==maxWorker-1) {
                myWorkers[i] =  new CodeWorker(i*block, (i+1)*block+mod);
            } else {
                myWorkers[i] =  new CodeWorker(i*block, (i+1)*block);
            }
        }
        for(int i = 0; i < maxWorker; i++) {
            myWorkers[i].start();
        }
        for(int i = 0; i < maxWorker; i++) {
            try {
                myWorkers[i].join();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    // Keszit egy fjlt a teszetleshez, ha nem talalja a FileToCode.txt-t
    public static File getJobFile() {
        File file = new File("FileToCode.txt");
        try {
            PrintWriter myPrintWriter = new PrintWriter(new FileWriter(file));
            for(int i = 0; i < BLOCK_COUNT; i++) {
                myPrintWriter.println("Korbbi akcijhoz hasonl jutalomversenyt hirdetett az iDefense labs. A cg azt szeretn");
                myPrintWriter.println("elrni, hogy a felhasznlk segtsgvel a Vista s az IE 7 minl tbb hibjra derljn");
                myPrintWriter.println("fny. Az iDefense ezttal 8000 dollrt knl annak, aki a Windows Vista vagy az Internet");
                myPrintWriter.println("Explorer 7 egy biztonsgi hibjra hvja fel a figyelmet, mg az gynevezett demokdokrt");
                myPrintWriter.println("4000 dollr jr. A vllalat vezeti hangslyoztk, hogy a tudomsukra jutott hibkat elszr");
                myPrintWriter.println("mindenkppen a fejlesztknek tovbbtjk s csak azutn hozzk nyilvnossgra, ha elkszlt");
                myPrintWriter.println("a biztonsgi rs javtsa. Az iDefense Labs mr tavaly februrban meghirdetett egy hasonl");
                myPrintWriter.println("programot, akkor 10 ezer dollros, azaz mintegy ktmilli forintos pnzjutalmat ajnlott fel");
                myPrintWriter.println("a Windows-t rint friss, ropogs biztonsgi hibkrt. A jutalom egy negyedvente megrendezend");
                myPrintWriter.println("verseny rszeknt, a Vulnerability Contributor Program (VCP) elnevezs projekt keretben tall gazdra.");
                myPrintWriter.println("2005 jliusban egy msik biztonsgi cg, a TippingPoint ajnlott pnzjutalmat azon hackerek");
                myPrintWriter.println("szmra, akik j sebezhetsgek felfedezsrl szmolnak be, mgpedig azrt, hogy gy elsknt");
                myPrintWriter.println("knlhasson megoldst a problmra.");
                myPrintWriter.println();
            }
            myPrintWriter.flush();
            myPrintWriter.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        return file;
    }
    
    
}
