// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.multiple;

import java.io.File;
import threadmark.IFarmer;

public class MultipleFarmer implements IFarmer {
    
    private MultipleWorker[] myWorkers;
    private static int FILE_COUNT = 20;  // A fajl ismetlesenek, "masolasanak" szama
    public static int LINE_COUNT = 3500; // LINE ismetlesenak szama  a kimenti fajlokban 
    public static File JOB_DIR;          // Munkakonyvtar
    
    public long getOperation(){
        return FILE_COUNT * LINE_COUNT;
    }
    
    public long getWriteBytes(){
        return LINE.getBytes().length * FILE_COUNT * LINE_COUNT;
    }
    
    public long getReadBytes(){
        return 0;
    }
    
    public void doWork(int maxWorker) {
        JOB_DIR = new File("MultipleFileTest");
        JOB_DIR.mkdir();
        myWorkers = new MultipleWorker[maxWorker];
        // Kimenti fajlok szetosztasa, a maradekot egyenletesen elosztva
        int mod = FILE_COUNT % maxWorker;
        for(int i = 0; i < maxWorker; i++) {
            int jobCount = FILE_COUNT / maxWorker;
            if(mod!=0) {
                jobCount++;
                mod--;
            }
            myWorkers[i] =  new MultipleWorker(jobCount);
        }
        for(int i = 0; i < maxWorker; i++) {
            myWorkers[i].start();
        }
        for(int i = 0; i < maxWorker; i++) {
            try {
                myWorkers[i].join();
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    public static String LINE =
            "HDHDFBH564FGV5JN4H89SCV6SECQWD4FB489TZJ4U6IK4UI6OIU456FV4FDJ564G5RTG46R4E8GTJAWE2855ETDR468H" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +            "HDHDFBH564FGV5JN4H89SCV6SECQWD4FB489TZJ4U6IK4UI6OIU456FV4FDJ564G5RTG46R4E8GTJAWE2855ETDR468H" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "RG4R65HH9TS99ER9GH31TZH1Z7JUU78IERGT5ZRG4R65ER9GH31TZH1Z7JUU78IHER9GH31TZH1Z7JUU78IH9TS99ERG" +
            "ERGAERQE9FER9GH31TZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ERVR4EGERG4R65HH9TS99ERGT5ZJHFTHDTRH4TGH" +
            "FV4FDJ564G5RTG46RTZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4ETZH1Z7JUU78IO47OPJ74HFXDVX53GX6DAS4E4E8" +
            "HDHDFBH564FGV5JN4H89SCV6SECQWD4FB489TZJ4U6IK4UI6OIU456FV4FDJ564G5RTG46R4E8GTJAWE2855ETDR468H";
}
