// Buczko Tamas
// ThreadTest 2006
// Siemens PSE
package test.prime;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import threadmark.IFarmer;

public class PrimeFarmer implements IFarmer {
    
    private static final int MAX = 10000; // Kereses felso hatara
    private PrimeWorker[] myWorkers;
    private PrintWriter myWriter;
    private long wBytes;
    
    public synchronized void println(String msg) {
        myWriter.println(msg);
        myWriter.flush();
        wBytes += msg.getBytes().length;
    }
    
    public long getOperation(){
        long op = 0;
        for(int i = 0; i < myWorkers.length; i++) {
            op += myWorkers[i].getOperation();
        }
        return op;
    }
    
    public long getWriteBytes(){
        return wBytes;
    }
    
    public long getReadBytes(){
        return 0;
    }
    
    public void doWork(int maxWorker) {
        try {
            File jobDir = new File("FindPrimesTest");
            jobDir.mkdir();
            File myFile = new File(jobDir, "WorkerCount_" +  Integer.toString(maxWorker) + ".txt");
            myWriter = new PrintWriter(new FileWriter(myFile));
            
            myWorkers = new PrimeWorker[maxWorker];
            // Keresesi tartomaynok kiosztasa
            int block = MAX / maxWorker;
            for(int i = 0; i < maxWorker; i++) {
                myWorkers[i] =  new PrimeWorker(this, i*block, (i+1)*block);
            }
            for(int i = 0; i < maxWorker; i++) {
                myWorkers[i].start();
            }
            for(int i = 0; i < maxWorker; i++) {
                try {
                    myWorkers[i].join();
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
            }
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
